/***************************************************/
/*   Midi Keyboard by Andrew Grabovets  (c) 2003   */
/*   Keyboard 6*8 for AT89CX051 oscilator 12 Mhz   */    
/*   www.cplusplus.boom.ru     cplusplus@land.ru   */
/***************************************************/

#include <C:\i8051\C51\INC\io51.h>

unsigned char i,y,i1,z;
unsigned char d[50];

void note_on(unsigned char n)
{
if ( d[n] == 0xFF)
{
d[n] =0xDF; /* 255 - 32 */
do{}while (TI == 0); TI = 0;
SBUF = 0x90;
do{}while (TI == 0); TI = 0;
SBUF = n + i1;
do{}while (TI == 0); TI = 0;		
SBUF = 0x7F;
}
}

void note_off(unsigned char n)
{
if ( d[n] != 0xFF)
if ( ++d[n] == 0xFF)
{
do{}while (TI == 0); TI = 0;
SBUF = 0x80;	
do{}while (TI == 0); TI = 0;
SBUF = n + i1;	
do{}while (TI == 0); TI = 0;		
SBUF = 0x7F;	
}
}

void note_off2(unsigned char n)
{
do{}while (TI == 0); TI = 0;
SBUF = 0x80;	
do{}while (TI == 0); TI = 0;
SBUF = n ;	
do{}while (TI == 0); TI = 0;		
SBUF = 0x7F;	
}

void init_port()
{
/* oscilator 12 Mhz */
P3 = P1 = 0xFF;
IE = 0x00;
PCON &= 0x7F;       /* 1/2 speed */
TH1  = 0xFF; 	/* speed =  31.25 Khz            */	
TL1  = 0xFF;	/* speed =  31.25 Khz            */
TMOD = 0x20;	/* mode   2,        interupt off */
TCON = 0x40;
SCON = 0x42;	/* mode   1,        flag off     */

/* torn off all open midi notes */
for (i = 0 ; i < 50 ; i++) d[i] = 0xFF;
for (i = 0 ; i < 128 ; i++) note_off2(i);
}

main()
{
init_port();
i1 = 39; /* F */
beg:
/** switch */
P1 = ~1; 
y = y;y = y; 
i1 = 27;
if (P3.0 == 0) i1 += 12;  /*  + oktava */ 
P1 = ~2; 
y = y;y = y; 
if (P3.0 == 0) i1 += 24; /* + 2 oktava */ 

/************/
y = 4;
for (i = 2 ; i < 8 ; i++)
{
P1 = ~y; 
/* time delay */
y = y;y = y; 
if (P3.0) note_off(i);  else note_on(i);  			
y = y + y;
}

/********/
y = 1;
for (i = 0 ; i < 8 ; i++)
{
P1 = ~y; 
/* time delay */
y = y;y = y; 
if (P3.2) note_off(i + 8);  else note_on(i + 8);  			
if (P3.3) note_off(i + 16); else note_on(i + 16);  			
if (P3.4) note_off(i + 24); else note_on(i + 24);  			
if (P3.5) note_off(i + 32); else note_on(i + 32);  			
if (P3.7) note_off(i + 40); else note_on(i + 40);  			
y = y + y;
}
goto beg;
}